︠f085dd0a-716b-4849-86fe-3f73a9c7d981︠
#3.2
reset()
import numpy as np
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
x = (np.sinc(100*t)) # discrete lowpass signal
lt=np.array(t).tolist() #convert array t to list
lx=np.array(x).tolist() #convert array x to list
Px=list_plot(zip(lt,lx),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
P1=text("t",(0.2,-0.2))
P2=text("$x_l(t)=\sinc(100t)$)",(0.1,1))
show(Px+P1+P2)
Fx=np.fft.fft(x) # Fast Fourier Transform
f=np.fft.fftfreq(len(t),1/fs) #Compute Discrete Fourier Transform sample frequencies
magx=np.abs(Fx)
lmagx=np.array(magx).tolist()
lf=np.array(f).tolist()
Mx=list_plot((zip(lf,lmagx)),plotjoined=true,figsize=(5,3),xmin=-550,xmax=550)
M1=text("f",(600,-0.2))
M2=text("$|X_l(f)|=\Pi(f/100)$)",(300,12.5))
show(Mx+M1+M2)
︡82e03d9c-b742-43d2-a008-30c2985b6e1f︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/218/tmp_3Vzda2.svg","show":true,"text":null,"uuid":"967ce1ed-1ab3-42d8-9ead-ae4188860e8e"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/218/tmp_IDoLRm.svg","show":true,"text":null,"uuid":"e9f21378-62c7-40de-b204-57f8a7961c9f"},"once":false}︡{"done":true}︡
︠90f7e141-1f09-4db5-b3dc-6f3720a839d2︠
#3.3
# Returns the lowpass equivalent of the signal x
# f0 is the center frequency
reset()
def loweq(x,t,f0):
    z=hilbert(x) # compute analytic signal, z(t)=x(t)+ix^(t)
    xl=z*np.exp(-i*2*pi*f0*t)
    return xl
︡1931dd0c-6fe8-4eca-bcec-c33338e25fe4︡{"done":true}︡
︠0e851296-29e9-43ee-9195-98835f5bfd05︠
#3.3
# lowpass signal xl(t) by numerical computation
# and its magnitude spectrum
import numpy as np
import matplotlib.pyplot as plt
from scipy.signal import hilbert, chirp
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
x = (np.sinc(100*t))*np.cos(2*np.pi*f0*t) # discrete bandpass signal
xl=loweq(x,t,f0)
Fx=np.fft.fft(xl) # Fast Fourier Transform
f=np.fft.fftfreq(len(t),1/fs) #Compute Discrete Fourier Transform sample frequencies
magx=np.abs(Fx)
lmagx=np.array(magx).tolist()
lf=np.array(f).tolist()
Mx=list_plot((zip(lf,lmagx)),plotjoined=true,figsize=(5,3),xmin=-550,xmax=550)
M1=text("f",(600,-0.2))
M2=text("$|X_l(f)|=\Pi(f/100)$)",(300,12.5))
show(Mx+M1+M2)
︡5f975c72-aca9-416b-9590-9942389b2a37︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/218/tmp_Prod85.svg","show":true,"text":null,"uuid":"4bb47a92-fd46-4af8-ba55-195e166392aa"},"once":false}︡{"done":true}︡
︠1b4e01f7-dfcd-4cb1-857f-cdc1d7c21533s︠
#3.1
# bandpass signal x(t)
# and its magnitude spectrum
import numpy as np
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
x = (np.sinc(100*t))*np.cos(2*np.pi*f0*t) # discrete bandpass signal
lt=np.array(t).tolist() #convert array t to list
lx=np.array(x).tolist() #convert array x to list
Px=list_plot(zip(lt,lx),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
P1=text("t",(0.2,-0.2))
P2=text("$x(t)=\sinc(100t)\cos(400\pi t$)",(0.1,1))
show(Px+P1+P2)
Fx=np.fft.fft(x) # Fast Fourier Transform
f=np.fft.fftfreq(len(t),1/fs) #Compute Discrete Fourier Transform sample frequencies magx=np.abs(Fx)
lmagx=np.array(magx).tolist()
lf=np.array(f).tolist()
Mx=list_plot((zip(lf,lmagx)),plotjoined=true,figsize=(5,3),xmin=-550,xmax=550)
M1=text("f",(600,-0.2))
M2=text("$|X(f)|=\Pi((f-f0)/100)+\Pi((f+f0)/100)$)",(300,5.5))
show(Mx+M1+M2)
︡a7764be9-16fa-4543-9d20-8ccb2f7f6a3f︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/218/tmp_zd7v3m.svg","show":true,"text":null,"uuid":"15ce03e9-9bb4-44f4-b265-4970cb71be37"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/218/tmp_dZKAoo.svg","show":true,"text":null,"uuid":"bb151192-6903-4cef-b7e4-358ed8c9b4c6"},"once":false}︡{"done":true}︡
︠724e534c-4829-4e1b-af94-8c4430f5049cs︠
#3.4
# In-phase component x_s(t) of x_l(t) and envelope V(t) of x(t)
# by analytic
# Returns the lowpass equivalent of the signal x
# f0 is the center frequency
reset()
import numpy as np
import matplotlib.pyplot as plt
from scipy.signal import hilbert, chirp
from scipy.fftpack import fft, ifft
f0=200 #center freq
duration = 4.0
fs = 1000.0 # number of samples/duration
samples = int(fs*duration)
t = -2+np.arange(samples)/fs #arange is used to construct array [0...samples-1]
xl = np.sinc(100*t) # discrete lowpass signal
xc=xl # discrete inphase component of lowpass signal
v=np.abs(xc) # discrete envelope of signal x(t)
lxc=np.array(xc).tolist()
lt=np.array(t).tolist()
lv=np.array(v).tolist()
Pxc=list_plot((zip(lt,lxc)),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
P1=text("t",(0.2,-0.2))
P2=text("$x_c(t)=\sinc(100t)$)",(0.1,1))
show(Pxc+P1+P2)
Mv=list_plot((zip(lt,lv)),plotjoined=true,figsize=(5,3),xmin=-0.2,xmax=0.2)
M1=text("t",(0.2,-0.2))
M2=text("$V(t)=|\sinc(100t)|$",(0.1,1))
show(Mv+M1+M2)
︡2fe5fbca-6b9f-4ea9-9515-e71bec35ff0d︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/218/tmp_wFlDXM.svg","show":true,"text":null,"uuid":"477c91e8-366e-499d-81ed-45b98635f77a"},"once":false}︡{"file":{"filename":"/home/user/.sage/temp/project-dba28504-d516-466d-9994-6d7dd7e0b988/218/tmp_ySD1D6.svg","show":true,"text":null,"uuid":"1b2e398f-7f2e-4fd5-a958-4ae3bc931c0a"},"once":false}︡{"done":true}︡
︠3b4de0a9-1ded-4bbf-a50c-e5138f492e89︠









